using System;

namespace PuntoMedio1{
	/// <summary>
	/// Dada la funcin f(x)= x^3-x -3 , encontrar una raz para el inter-
	/// valo [1,2] de su dominio. Usar E=0,1 y Nmax=10.
	/// </summary>
	class PM{
		
		[STAThread]
		static void Main(){
			double a=1,b=2;
			if ((Continua(a,b)==1))PM.Raiz(a,b);
			else Console.WriteLine("No tiene raiz");	
			Console.Read();
			return;
		}

		//Funcion para comprobar Teorema de Bolzano
		static int Continua(double a,double b){
			if(((PM.Evaluar(a)<0)&&(PM.Evaluar(b)>0))||((PM.Evaluar(a)>0)&&(PM.Evaluar(b)<0))) 
				return 1;
			else return 0;
		}

		//Funcin Evaluar si corresponde al intervalo[1,2]
		static double Evaluar(double num){
			num=Math.Pow(num,3)-num-3;
			return num;
		}

		//Funcin para hallar la mejor aproximacin a la raiz.
		static void Raiz(double a, double b){
			double raiz=0;int n=0;
			while((Math.Abs(a-b)>0.1)&&(n<10)){
				raiz=(a+b)/2;
				PM.Evaluar(raiz);
				if((PM.Evaluar(a)*PM.Evaluar(raiz))>0)a=raiz;
				else b=raiz;
				n++;
			}
			Console.Write("\nBusc la aproximacin "+n+" veces");
			Console.Write("\nLa raiz para el intervalo [1,2] de su dominio es: "+raiz);
			return;
		}
	}
}
